/* MailTweak internal component - Copyright (C) 2007 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://journal.mozdev.org/mailtweak.html */
MailTweak = {
tweaks: [
"AddrLines","DontSave","InsertMenu","KeepCopy","NoSubject","PermaPen","Personal","WordCount"
],pref: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extension.mailtweak."),init: function () {
var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extension.mailtweak.")
addEventListener("load", function () {MailTweak.load(false)}, false)
document.getElementById("msgcomposeWindow").addEventListener("compose-window-reopen", function () {MailTweak.load(true)}, false)},load: function (recycled) {
for each (var t in this.tweaks)
if (this.pref.getBoolPref(t.toLowerCase())) this[t].load(recycled)
dump(">> load foob \n")
var zzz = _awSetInputAndPopup
_awSetInputAndPopup = function (inputValue, popupValue, parentNode, templateNode) {
dump(" > _awSetInputAndPopup " + inputValue + "\n")
if (!inputValue) popupValue = "addr_bcc"
zzz(inputValue, popupValue, parentNode, templateNode)}},toString: function () {return "[object MailTweak]"},AddrLines: {
load: function (recycled) {
if (recycled) return
setTimeout('MailTweak.AddrLines.adjust()', 0)},adjust: function () {
var n = MailTweak.pref.getIntPref("addrlines.lines")
var list = document.getElementById("addressingWidget")
var row = list.getItemAtIndex(0).boxObject.height
var ab = document.getElementById("addresses-box")
var h1 = ab.firstChild.boxObject.height
+ row
+ ab.lastChild.boxObject.height
+ 4
var hn = h1 + (n - 1) * row
with (document.getElementById("MsgHeadersToolbar").style)
minHeight = String(h1) + "px",height = String(hn) + "px"
awCreateOrRemoveDummyRows()}},DontSave: {
load: function (recycled) {
if (recycled) return
this._ccc = ComposeCanClose
ComposeCanClose = this.canClose},canClose: function () {
if (gContentChanged || gMsgCompose.bodyModified || gAutoSaveKickedIn)
return true
else
return MailTweak.DontSave._ccc()}},InsertMenu: {
load: function (recycled) {
if (recycled) return
document.getElementById("mailtweak-import").hidden = false
if (gMsgCompose.composeHTML) return
document.getElementById("insertMenu").hidden = false
for each (var id in ["cmd_image", "cmd_InsertTable", "cmd_link", "cmd_anchor", "cmd_hline","cmd_insertHTMLWithDialog", "insertTOC", "insertMenuSeparator", "cmd_insertBreakAll"])
document.getElementById(id).setAttribute("hidden", true)},import: function (elem) {
var FP = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker)
FP.init(self, elem.getAttribute("label"), 0)
FP.appendFilters(4)
FP.appendFilters(1)
if (FP.show() != 0) return
var fs = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream)
fs.init(FP.file, 1, 0, 0)
var ss = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream)
ss.init(fs)
if (gMsgCompose.composeHTML) doStatefulCommand("cmd_paragraphState", "pre")
GetCurrentEditor().insertText(ss.read(ss.available()))
ss.close()
fs.close()}},KeepCopy: {
MAM: Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager),RDF: Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService),fakeid: null,fcc: null,type: 0,GenericSendMessage: function (type) {
var my = MailTweak.KeepCopy
my.type = type
var ask = !MailTweak.pref.getBoolPref("keepcopy.noprompt")
&& my.type <= 1
&& my.fcc === null
if (ask) {
var fcc2 = gMsgCompose.compFields.fcc2
ask = ask && !(fcc2 && fcc2.indexOf("mailbox:") == 0)}
if (ask) {
var f = my.RDF.GetResource(getCurrentIdentity().fccFolder).QueryInterface(Components.interfaces.nsIMsgFolder)
var sent = f.prettiestName
while (f = f.parent) sent = f.prettiestName + "/" + sent
var k = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService).confirmEx(
window,my._checkbox.getAttribute("label"),my._checkbox.getAttribute("prompt").replace(/#/, sent),0x40203,null, null, null, null, {})
if (k == 1) return
if (k == 2) my.fcc = false, my._checkbox.removeAttribute("checked")}
my._gsm(type)},getCurrentIdentity: function () {
var my = MailTweak.KeepCopy
var id = my._gci()
if (gAutoSaving || my.fcc !== false) return id
my.fakeid.copy(id)
my.fakeid.doFcc = false
return my.fakeid},load: function (recycled) {
if (recycled) return
this._checkbox = document.getElementById("mailtweak-keepcopy")
this._checkbox.hidden = false
this.fcc = null
this.fakeid = this.MAM.createIdentity()
this.init()
addEventListener("unload", function () {MailTweak.KeepCopy.unload()}, false)
addEventListener("compose-window-init", function () {MailTweak.KeepCopy.init(true)}, true)
addEventListener("compose-from-changed", function () {MailTweak.KeepCopy.init(false)}, true)
this._gsm = GenericSendMessage
GenericSendMessage = this.GenericSendMessage
this._gci = getCurrentIdentity
getCurrentIdentity = this.getCurrentIdentity},init: function (recycle) {
if (recycle) this.fcc = null
var ok = gCurrentIdentity.doFcc
this._checkbox[ok? "removeAttribute":"setAttribute"]("disabled", "true")
var tick = ok && (this.fcc || this.fcc === null)
this._checkbox[tick? "setAttribute":"removeAttribute"]("checked", "true")},toggle: function () {
this.fcc = this._checkbox.hasAttribute("checked")},unload: function () {
if (this.fakeid) {
this.MAM.removeIdentity(this.fakeid)
this.fakeid = null}}},NoSubject: {
load: function (recycled) {
if (recycled) return
this._gsm = GenericSendMessage
GenericSendMessage = this.send
this.dummyPS.__proto__ = gPromptService},send: function (type) {
if (type < 2) gPromptService = MailTweak.NoSubject.dummyPS
MailTweak.NoSubject._gsm(type)
if (type < 2) gPromptService = MailTweak.NoSubject.dummyPS.__proto__},dummyPS: {
prompt: function (w, t, m, result) {
var s = MailTweak.pref.getComplexValue(
"nosubject.text",Components.interfaces.nsISupportsString)
result.value = s.toString()
return true},}},PermaPen: {
keyspec: "",face: "",size: 0,color: "",ground: "",styleSet: [],styleNot: [],_active: false,activate: function (ok) {
if (ok === true || ok === false) this._active = ok
else this._active = !this._active
document.getElementById("ColorButtons").style.borderLeftColor = this._active? this.color : "transparent"
document.getElementById("mailtweak-permapen")
[this._active? "setAttribute":"removeAttribute"]("checked", "true")},keyPress: function (event) {
if (!IsHTMLEditor() || !this._active) return
with (GetCurrentEditor()) {
// dump(">> " + here + "\n")
if (this.face) setInlineProperty(this._font, "face", this.face)
if (this.size) setInlineProperty(this._font, "size", this.size)
if (this.color) setInlineProperty(this._font, "color", this.color)
setInlineProperty(this._font, "style", this._style)}
for each (var cmd in this.styleSet) {
cmd = "cmd_" + cmd
var on = top.document.getElementById(cmd).getAttribute("state") == "true"
if (!on) doStyleUICommand(cmd)}
for each (var cmd in this.styleNot) {
cmd = "cmd_" + cmd
var on = top.document.getElementById(cmd).getAttribute("state") == "true"
if (on) doStyleUICommand(cmd)}},load: function (recycled) {
if (recycled) return
this._active = false
var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extension.mailtweak.permapen.")
this.keyspec = pref.getCharPref("key")
this.face = pref.getCharPref("face")
this.size = pref.getIntPref("size")
this.color = pref.getCharPref("color")
this.ground = pref.getCharPref("ground")
this[pref.getBoolPref("bold")? "styleSet":"styleNot"].push("bold")
this[pref.getBoolPref("italic")? "styleSet":"styleNot"].push("italic")
this[pref.getBoolPref("underline")? "styleSet":"styleNot"].push("underline")
with (document.getElementById("ColorButtons").style)
borderStyle = "solid",borderWidth = "0 0 0 2px",borderLeftColor = "transparent"
if (!gAtomService) GetAtomService()
this._font = gAtomService.getAtom("font")
var rgb = function (c) {
return "rgb("
+ Number("0x" + c.substr(1, 2)) + ", "
+ Number("0x" + c.substr(3, 2)) + ", "
+ Number("0x" + c.substr(5, 2)) + ")"}
// "color: " + rgb(this.color) + "; "
this._style = "background-color: " + rgb(this.ground) + ";"
var m = document.getElementById("mailtweak-permapen")
m.removeAttribute("hidden")
with (m.parentNode)
insertBefore(removeChild(m), document.getElementById("removeSep"))
var k = this.keyspec.split(" ")
with (document.getElementById("mailtweak-permapen-key")) {
setAttribute("keycode", k.pop())
setAttribute("modifiers", k.join(" "))}
addEventListener("keypress",function (event) {MailTweak.PermaPen.keyPress(event)},true)},toString: function () {return "[object MailTweak.PermaPen]"}},Personal: {
load: function (recycled) {
if (recycled) return
document.getElementById("mailtweak-personal").hidden = false},activate: function () {
addEventListener("compose-send-message", this.ready, true)
GenericSendMessage(1)},ready: function () {
removeEventListener("compose-send-message", MailTweak.Personal.ready, true)
MailTweakService.personalizer.activate(getCurrentIdentity())},toString: function () {return "[object MailTweak.Personal]"}},WordCount: {
oneWord: "",manyWords: "",oneChar: "",manyChars: "",timer: null,showing: false,count: function () {
var txt = this._selection.toString().replace(/[\r\n]/g, "")
var c = txt.length
var wds = txt.match(/(^|\s+)\S/g)
var w = wds? wds.length : 0
if (document.getElementById("status-bar").hidden)
goToggleToolbar("status-bar", "menu_showTaskbar")
this._status.label = c == 0 ? "" :
(w == 1 ? this.oneWord : this.manyWords.replace("#", w))
+ (c == 1 ? this.oneChar : this.manyChars.replace("#", c))
this.showing = true},load: function (recycled) {
if (recycled) return
with (document.getElementById("selectEditMenuItems"))
setAttribute("oncommandupdate", getAttribute("oncommandupdate") + ";countWords()")
countWords = function () {
var sel = null
with (document.getElementById("content-frame"))
try {sel = getEditor(contentWindow).selection}
catch (ex) {}
if (sel) sel.QueryInterface(Components.interfaces.nsISelectionPrivate).addSelectionListener(MailTweak.WordCount)
else dump("countWords - no editor selection \n")}
with (document.getElementById("mailtweak-data"))
this.oneWord = getAttribute("one"),this.manyWords = getAttribute("many"),this.oneChar = getAttribute("onechar"),this.manyChars = getAttribute("manychar")
this._status = document.getElementById("statusText")},notifySelectionChanged: function (doc, sel, why) {
if (why == 0) return
if (this.showing && sel.toString() == "") {
this._status.label = ""
this.showing = false
return}
this._selection = sel
if (this.timer) clearTimeout(this.timer)
this.timer = setTimeout(function () {MailTweak.WordCount.count()}, 300)}}}
MailTweak.init()